BorderedMorph subclass: #ArgMorph
	instanceVariableNames: 'labelMorph implicitValue '
	classVariableNames: 'DropDownMenuForm '
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
!ArgMorph commentStamp: '<historical>' prior: 0!
I am an abstract superclass for all kinds of argument morphs--morphs that are used to hold the argument for various kinds of BlockMorph.
!


!ArgMorph methodsFor: 'drawing' stamp: 'jm 3/28/2005 16:00'!
drawHLineFrom: startX to: endX y: yOffset color: c on: aCanvas

	| y |
	y _ self top + yOffset.
	aCanvas
		fillRectangle: ((self left + startX)@y corner: (self left + endX)@(y + 1))
		color: c.
! !


!ArgMorph methodsFor: 'other' stamp: 'jm 7/7/2004 00:23'!
acceptsDroppedReporters
	"Answer true if I accept dropped reporter blocks. Answer false by default."

	^ false
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 3/28/2005 19:18'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	^ false
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 3/28/2005 15:12'!
defaultValue: anObject
	"Set my default value. This default implementation does nothing."
! !

!ArgMorph methodsFor: 'other' stamp: 'CWB 9/28/2011 19:24'!
exportArgWith: anExporter havingSpec: aSpec
	"Exports the given argument"

	"self printArgOn: anExporter codeStream."

	self labelMorph ifNotNil: [
		anExporter exportLiteralValue: (self evaluate) on: (anExporter codeStream).
	].
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 8/24/2003 16:57'!
fixArgLayout
	"Fix my layout. This default implementation does nothing."! !

!ArgMorph methodsFor: 'other' stamp: 'jm 12/9/2008 17:31'!
isArgMorph
	"True only for ArgMorphs."

	^ true
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 12/9/2008 17:35'!
isBlockMorph
	"True only for BlockMorphs."

	^ false
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 3/15/2003 12:21'!
isReporter
	"Answer true since every ArgMorph reports a value."

	^ true
! !

!ArgMorph methodsFor: 'other' stamp: 'jm 10/21/2003 12:32'!
labelMorph

	^ labelMorph
! !


!ArgMorph methodsFor: 'object i/o' stamp: 'jm 9/24/2003 18:25'!
fieldsVersion

	^ 1
! !

!ArgMorph methodsFor: 'object i/o' stamp: 'jm 9/24/2003 18:25'!
initFieldsFrom: anObjStream version: classVersion

	super initFieldsFrom: anObjStream version: classVersion.
	self initFieldsNamed: #(
		labelMorph
	) from: anObjStream.
! !

!ArgMorph methodsFor: 'object i/o' stamp: 'jm 9/24/2003 18:33'!
storeFieldsOn: anObjStream

	super storeFieldsOn: anObjStream.
	self storeFieldsNamed: #(
		labelMorph
	) on: anObjStream.
! !


!ArgMorph methodsFor: 'BYOB' stamp: 'jens 2/22/2010 23:10'!
defaultValue

	| def pos pname val |
	(owner respondsTo: #definition)
		ifFalse: [^ nil].
	def _ owner definition.
	pos _ (owner submorphs select: [:sm | sm isKindOf: ArgMorph]) indexOf: self.
	pname _ def parameterNames at: pos.
	val _ def defaultOf: pname.
	val = '' ifTrue: [^ nil].
	^ val! !

!ArgMorph methodsFor: 'BYOB' stamp: 'jens 2/1/2010 21:19'!
implicitValue
	^ implicitValue! !

!ArgMorph methodsFor: 'BYOB' stamp: 'jens 2/1/2010 21:18'!
implicitValue: anObject
	implicitValue _ anObject! !

!ArgMorph methodsFor: 'BYOB' stamp: 'jens 1/5/2010 03:48'!
isEmptySlot
	^true! !

!ArgMorph methodsFor: 'BYOB' stamp: 'JM 8/12/2011 14:27'!
printArgOn: aStream
	"Print this argument morph on the given stream."

	| v |
	self labelMorph ifNotNil: [
		v _ self evaluate.
		(v isKindOf: String)
			ifTrue: [aStream nextPutAll: '"', v, '"']
			ifFalse: [aStream nextPutAll: v asString ]].

! !


!ArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 20:51'!
fixBlockOrArgLayout
	"This type of morph needs to fix its argument layout"

	^ self fixArgLayout.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ArgMorph class
	instanceVariableNames: ''!

!ArgMorph class methodsFor: 'class initialization' stamp: 'jm 6/22/2007 12:49'!
initialize
	"self initialize"

	DropDownMenuForm _ Form
		extent: 7@4
		depth: 1
		fromArray: #(4261412864 2080374784 939524096 268435456)
		offset: 0@0.
	DropDownMenuForm _ DropDownMenuForm colorReduced.  "become a ColorForm"
	DropDownMenuForm colors:
		(Array with: Color transparent with: (Color gray: 0.25)).

! !


!ArgMorph class methodsFor: 'byob lambdas' stamp: 'jens 11/11/2009 19:59'!
dropDownMenuForm
	^DropDownMenuForm! !


ArgMorph initialize!
