BorderedMorph subclass: #WatcherReadoutFrameMorph
	instanceVariableNames: 'frameLayoutNeeded complexObject '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Watchers'!
!WatcherReadoutFrameMorph commentStamp: '<historical>' prior: 0!
Frame to hold the readout of a WatcherMoroph.
!


!WatcherReadoutFrameMorph methodsFor: 'initialization' stamp: 'jm 8/6/2008 19:39'!
initialize

	super initialize.
	borderColor _ Color white.
! !


!WatcherReadoutFrameMorph methodsFor: 'accessing' stamp: 'jm 8/6/2008 19:39'!
isLarge
	"Support for reading old Watchers; do not remove!!"

	^ submorphs size > 0 and: [self firstSubmorph font pointSize > 10]
! !


!WatcherReadoutFrameMorph methodsFor: 'drawing' stamp: 'jm 8/21/2006 13:51'!
drawBorderOn: aCanvas

	"border lines"
	aCanvas
		line: (self topLeft + (2@0)) to: (self topRight - (3@0)) color: borderColor;
		line: (self topLeft + (0@2)) to: (self bottomLeft - (0@3)) color: borderColor;
		line: (self bottomLeft + (2@(-1))) to: (self bottomRight - (3@1)) color: borderColor;
		line: (self bottomRight - (1@3)) to: (self topRight + ((-1)@2)) color: borderColor.

	"border corners"
	aCanvas
		line: (self topLeft + (1@1)) to: (self topLeft + (1@1)) color: borderColor;
		line: (self topRight - (2@(-1))) to: (self topRight - (2@(-1))) color: borderColor;
		line: (self bottomRight - (2@2)) to: (self bottomRight - (2@2)) color: borderColor;
		line: (self bottomLeft - ((-1)@2)) to: (self bottomLeft - ((-1)@2)) color: borderColor.
! !

!WatcherReadoutFrameMorph methodsFor: 'drawing' stamp: 'jens 1/19/2011 23:54'!
drawOn: aCanvas

	"fill inside"
	aCanvas
		fillRectangle: (Rectangle origin: (self topLeft + (2@1)) corner: (self bottomRight - (2@1))) color: color;
		fillRectangle: (Rectangle origin: (self topLeft + (1@2)) corner: (self bottomRight - (1@2))) color: color.

	"white border"
	self drawBorderOn: aCanvas.

	"inner shadows"
	aCanvas
		line: (self topLeft + (2@1)) to: (self topRight - (3@-1)) color: (self color darker darker);
		line: (self topLeft + (1@2)) to: (self bottomLeft - (-1@3)) color: (self color darker darker);
		line: (self topLeft + (2@2)) to: (self topRight - (3@-2)) color: (self color darker);
		line: (self topLeft + (2@2)) to: (self bottomLeft - (-2@2)) color: (self color darker);
		line: (self bottomLeft - (-2@2)) to: (self bottomRight - (3@2)) color: (self color darker);
		line: (self topRight - (2@-2)) to: (self bottomRight - (2@3)) color: (self color darker).

	(complexObject isKindOf: Morph) ifTrue: [
		| form |
		(complexObject respondsTo: #displayForm)
			ifTrue: [form _ complexObject displayForm]
			ifFalse: [ (complexObject respondsTo: #thumbnailImageForm)
				ifTrue: [form _ complexObject thumbnailImageForm]
				ifFalse: [form _ complexObject imageForm]].
		aCanvas paintImage: form at: self position + (5@5)]

! !


!WatcherReadoutFrameMorph methodsFor: 'object i/o' stamp: 'jm 8/21/2006 14:03'!
fieldsVersion

	^ 1
! !


!WatcherReadoutFrameMorph methodsFor: 'encapsulatedScripts' stamp: 'jens 11/2/2009 22:00'!
complexObject
	^complexObject! !

!WatcherReadoutFrameMorph methodsFor: 'encapsulatedScripts' stamp: 'jens 7/16/2010 00:30'!
complexObject: anObject
	| newListWatcher |

	complexObject _ anObject.

	(anObject isKindOf: ScratchListMorph) ifTrue: [
		submorphs _ submorphs copyWithout: anObject.
		anObject position: self position + 5.
		self addMorphBack: anObject.
		anObject fixLayout.
		anObject startStepping.
		^ self].

	(anObject isKindOf: BYOBList) ifTrue: [
		newListWatcher _ BYOBListWatcherMorph new 
							listName: '' target: nil; 
							list: anObject; 
							updateCountMorph; 
							yourself.
		newListWatcher fixLayout.
		submorphs _ submorphs reject: [:each |
			each isKindOf: newListWatcher class ].
		newListWatcher position: self position + 5.
		self addMorphBack: newListWatcher.
		newListWatcher fixLayout.
		newListWatcher startStepping]! !

!WatcherReadoutFrameMorph methodsFor: 'encapsulatedScripts' stamp: 'jens 1/20/2011 00:38'!
fixLayout

	| watcher readout isLarge s e readoutWidth yOffset w inset blist |

	((submorphs size = 1) and: [submorphs first isKindOf: StringMorph]) ifFalse: [^ self].

	watcher _ self ownerThatIsA: WatcherMorph.
	readout _ submorphs first.

	isLarge _ watcher ifNil: [false] ifNotNil: [watcher isLarge].
	s _ readout contents.
	isLarge
		ifTrue: [self width: 50]
		ifFalse: [self width: 40].

	(s isKindOf: Form) 
		ifTrue: [
			readout extent: s extent.

			self extent: readout extent +( 10@10).
			readout position: self position + (5@5).
			^self layoutChanged ]

		ifFalse: [
			blist _ submorphs detect: [:sm | sm isKindOf: BYOBListWatcherMorph] ifNone: [nil].
			blist ifNotNil: [
				readout extent: blist extent.
				self extent: blist extent +( 10@10).
				readout position: self position + (5@5).
				^self layoutChanged ]].

	e _ ScratchTranslator stringExtent: s font: readout font.
	readoutWidth _ e x.
	(readoutWidth + 10) > self width ifTrue: [self width: readoutWidth + 12].
	self width > (readoutWidth + 50) ifTrue: [self width: readoutWidth + 50].

	readout contents: (UTF8 withAll: readout contents).
	"set height"
	isLarge
		ifTrue: [self height: (e y max: 23)]
		ifFalse: [self height: (e y max: 14)].

	yOffset _ (self height // 2) - (ScratchTranslator centerOffsetForButtonWithFont: readout font) + 1.
	(((s indexOf: $.) = (s size - 2)) and: [((s indexOf: $.) = 0) not]) "one digit after the decimal point"
		ifTrue: [  "right-justify the string"
			w _ (ScratchTranslator stringExtent: (s copyUpTo: $.) font: readout font) x.
			inset _ (ScratchTranslator stringExtent: '.0' font: readout font) x.
			self isLarge ifTrue: [inset _ inset + 1].
			readout position: self topRight - ((w + inset + 5) @ (-1 * yOffset))]
		ifFalse: [
			readout position: self position + (((self width - readoutWidth) // 2) @ yOffset)].
	(readout bottom > self bottom) ifTrue: [readout bottom: self bottom].
	(readout top < self top) ifTrue: [readout top: self top].

	isLarge ifFalse: [
		watcher  ifNotNil: [watcher layoutForViewer]].

	self layoutChanged.
! !
